###############################################################################
# This perl module contains the configuration information for this parser.
# If you don't understand the format of this configuration file DON'T TOUCH IT.
###############################################################################
# Licensed Materials - Property of IBM
#
# 5724-W86 5724-X63
#
# (C) Copyright IBM Corp. 2003, 2010. All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
###############################################################################

package OBJ_ID_XFORM;

use AudLog;    #v900r011

my $obj_id_xform = {
	'B50331649' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		delete $d_ref->{RNC_ID};
	},
	'B67109393' => 'NEIGHBOUR_ID',
	#'B67109394' => 'NEIGHBOUR_ID',
	#'B67109395' => 'NEIGHBOUR_ID',
	'B67109394' => sub {    #v900r011
		my ( $d_ref, $blockname, $oname ) = @_;
		if ( $d_ref->{$oname} =~ /^UCELL_GCELL/ ) {
			$d_ref->{NEIGHBOUR_ID} = $d_ref->{RNC_ID} . '/' . $d_ref->{$oname};
			#$d_ref->{Proc_Type}    = 'V900';    #comment for alm00155493
		}
		else {
			#NEIGHBOUR_ID does not contain RNC_ID
			$d_ref->{NEIGHBOUR_ID} = $d_ref->{$oname};
			#$d_ref->{Proc_Type}    = 'V';    #comment for alm00155493
		}
		delete $d_ref->{$oname};
	},
	'B67109395' => sub {    #v900r011
		my ( $d_ref, $blockname, $oname ) = @_;
		if ( $d_ref->{$oname} =~ /^UCELL_NCELL/ ) {
			my ( $f1, $f2, $f3, $f4, $f5, $f6, $f7 ) = split( '/', $d_ref->{$oname}, 7 );
			$d_ref->{NEIGHBOUR_ID} = $d_ref->{RNC_ID} . '/' . $f3 . '/' . $f4 . '_' . $f5 . '/' . $f6 . '_' . $f7;
			#$d_ref->{Proc_Type}    = 'V900';    #comment for alm00155493
			$d_ref->{CELL_ID} = $f3;    #add for alm00199134
			$d_ref->{DEST_RNC_ID} = $f4 . '_' . $f5;
		}
		else {
			#NEIGHBOUR_ID does not contain RNC_ID
			$d_ref->{NEIGHBOUR_ID} = $d_ref->{$oname};
			#$d_ref->{Proc_Type}    = 'V';    #comment for alm00155493
		}
		delete $d_ref->{$oname};
	},
	'B67109396' => 'NEIGHBOUR_ID',
	'B67109397' => \&proc_id,
	'B67109398' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{FRAATM_Id} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		delete $d_ref->{$oname};
	},
	'B67109399' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{FRAIMALNK_Id} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		delete $d_ref->{$oname};
	},
	'B67109401' => \&proc_id,
	
	'B67109402' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;
		#$d_ref->{$oname} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname}; #commented during build 1 v900r011. changed to below.
		$d_ref->{$oname} = $d_ref->{$oname};
	},
	
	'B67109403' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;
		#$d_ref->{$oname} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname}; #commented during v900r011. changed to below.
		$d_ref->{$oname} = $d_ref->{$oname};
	},
	
	'B67109404' => \&proc_id,
	'B67109415' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{$oname} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
	},
	'B67109416' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{$oname} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
	},
	'B67109417' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{$oname} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
	},
	'B67109418' => \&proc_id,
	
	'B67109451' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;
		#$d_ref->{$oname} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname}; commented during v900r011 build 1. changed to below.
		$d_ref->{$oname} = $d_ref->{$oname};
	},
	
	'B67109456' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{UNILNK_Id}   = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		$d_ref->{UNILNK_Name} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		delete $d_ref->{$oname};
	},
	'B67109458' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{$oname} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
	},

	#'B67109456' => 'UNILNK_Id',
	'B67109453' => \&proc_id,
	'B67109457' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{IPOA_Id} = $d_ref->{$oname};
		delete $d_ref->{$oname};

		#$d_ref->{IPOA_Id} =~ s/IPOALNK\///g;
		#delete $d_ref->{OBJECT_ID};
	},
	'B67109464' => 'ATM_Port_Id',
	'B67109465' => 'IPOAPVC_Id',
	'B67109466' => 'AAL2PATH_Id',
	'B67109467' => 'IPPATH_Id',
	'B67109468' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{SCTPLNK_Id} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		delete $d_ref->{$oname};
	},
	'B67109469' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{SCTPIP_Id} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		delete $d_ref->{$oname};
	},
	'B67109470' => 'IPPATHPING_Id',
	'B67109475' => 'IPNODECONN_Id',
	'B67109476' => 'IPNODETRM_Id',
	'B67109477' => 'AAL2PATH_Id',
	'B67109481' => 'IPNODECONN_Id',
	'B67109482' => 'M3UA_Link_Id',
	'B67109483' => 'M3UA_LinkSet_Id',
	'B67109484' => 'M3UA_Point_Id',
	'B67109485' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{SCTPLNK_Id} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		delete $d_ref->{$oname};
	},
	'B67109486' => 'AAL2PATH_Id',
	'B67109487' => sub {            #v900r011
		my ( $d_ref, $blockname, $oname ) = @_;
		$d_ref->{$oname} =~ s/No./No/g;
	},
	'B67109488' => 'ETH_Id',
	'B67109490' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{MLPPP_Id}   = $d_ref->{$oname};
		$d_ref->{MLPPP_Name} = $d_ref->{$oname};
		delete $d_ref->{$oname};
	},
	'B67109491' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{PPP_Id}   = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		$d_ref->{PPP_Name} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		delete $d_ref->{$oname};
	},
	'B67109492' => \&proc_id,
	'B67109493' => \&proc_id,
	'B67109494' => \&proc_id,
	'B67109495' => 'IPPATH_Id',
	'B67109497' => \&proc_id,
	'B67109498' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{$oname} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
	},
	'B67109500' => 'IPNODETRM_Id',
	'B67109511' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{PPP_Id}   = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		$d_ref->{PPP_Name} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		delete $d_ref->{$oname};
	},
	'B67109512' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{MLPPP_Id}   = $d_ref->{$oname};
		$d_ref->{MLPPP_Name} = $d_ref->{$oname};
		delete $d_ref->{$oname};
	},
	'B67109513' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{QosQueue_Id}   = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		$d_ref->{QosQueue_Name} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		delete $d_ref->{$oname};
	},
	'B67109514' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{ETH_Id} = $d_ref->{$oname};
		$d_ref->{ETH_Id} =~ s/No\./No/g;
	},
	'B67109515' => \&proc_id,
	'B67109516' => \&proc_id,

	'B67109517' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		#$d_ref->{SAALLink_Id} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname}; #commented during v900r011. changed to below line.
		$d_ref->{SAALLink_Id} = $d_ref->{$oname};

		$d_ref->{OBJECT_ID} = $d_ref->{SAALLink_Id};
	},

	'B67109519' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		# This is to set the default value in case CNOPERATOR don't exist
		$d_ref->{CNNAME}  = $d_ref->{RNC_ID};
		$d_ref->{CNINDEX} = '0';
	},
	'B67109520' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{OBJECT_ID} = $d_ref->{RNC_ID} . "/" . $d_ref->{OBJECT_ID};
	},
	'B67109526' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;
		my ( $f1, $f2, $f3 ) = split( '/', $d_ref->{OBJECT_ID}, 3 );
		$f1 .= '/';
		$f1 .= $f2;
		$d_ref->{OBJECT_ID} = $f1;
	},
	'B67109534' => 'IPPATH_Id',
	'B67109537' => \&proc_id,
	'B67109539' => 'IPPATH_Id',
	'B67109540' => 'IPPATH_Id',
	'B67109542' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{MLPPP_Id}   = $d_ref->{$oname};
		$d_ref->{MLPPP_Name} = $d_ref->{$oname};
		delete $d_ref->{$oname};
	},
	'B67109543' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		$d_ref->{PPP_Id}   = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		$d_ref->{PPP_Name} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};
		delete $d_ref->{$oname};
	},
	'B67109544' => 'ETH_Id',

	'B67109546' => sub {    #v900r011
		my ( $d_ref, $blockname, $oname ) = @_;
		$d_ref->{$oname} =~ s/INDEX\//INDEX_/;
		#$d_ref->{$oname} = $d_ref->{RNC_ID} . '/' . $d_ref->{$oname}; #commented during build 1. corrected as next line.
		$d_ref->{$oname} = $d_ref->{$oname}; 
	},
	'B67109549' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;
		my ( $f1, $f2, $f3 ) = split( '/', $d_ref->{OBJECT_ID}, 3 );
		$f1 .= '_';
		$f1 .= $f2;
		$f1 .= '/';
		$f1 .= $f3;
		$d_ref->{OBJECT_ID} = $f1;
	},

	'B67109550' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		#MTP3Dsp/Label_SHBRNC504/DPX_4
		my ( $f1, $f2, $f3 ) = split( '/', $d_ref->{OBJECT_ID}, 3 );
		$f1 .= '_';
		$f1 .= $f2;
		$f1 .= '/';
		$f1 .= $f3;
		$d_ref->{OBJECT_ID} = $f1;

	},

	'B67109551' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		# MTP3LinkSet/Label_SHBRNC402/INDEX_0/MTP3Link/Label_SHBRNC402_4/LKS_0/SLC_4
		my ( $f1, $f2, $f3, $f4, $f5, $f6, $f7 ) = split( '/', $d_ref->{OBJECT_ID}, 7 );
		if ( $f1 eq 'MTP3LinkSet' ) {
			$f1                      = $f1 . '_' . $f2 . '/' . $f3;
			$d_ref->{MTP3LinkSet_Id} = $f1;
			$d_ref->{OBJECT_ID}      = $f1 . '/' . $f4 . '_' . $f5 . '/' . $f6 . '/' . $f7;
		}

		#MTP3LNK/Label_M3LNK1/LKS_4/SLC_1	#v900r011
		else {
			$d_ref->{OBJECT_ID} = $f1 . '_' . $f2 . '/' . $f3 . '/' . $f4;
		}
	},

	'B67109552' => sub {
		my ( $d_ref, $blockname, $oname ) = @_;

		#MTP3LinkSet/Label_SHBRNC404/INDEX_1
		my ( $f1, $f2, $f3 ) = split( '/', $d_ref->{OBJECT_ID}, 3 );
		$f1 .= '_';
		$f1 .= $f2;
		$f1 .= '/';
		$f1 .= $f3;
		$d_ref->{OBJECT_ID} = $f1;
	},
	'B67109564' => sub {    #v900r011
		my ( $d_ref, $blockname, $oname ) = @_;
		#$d_ref->{$oname} = $d_ref->{RNC_ID} . '/' . $d_ref->{$oname}; ## commented during build 1 fix 
		$d_ref->{$oname} = $d_ref->{$oname};
	},
	'B82833917' => sub {    #v900r011
		my ( $d_ref, $blockname, $oname ) = @_;
		my ( $f1, @rest ) = split( '/', $d_ref->{$oname}, 3 );
		$d_ref->{Processor_Type} = $d_ref->{RNC_ID} . '/' . $f1;        #should be in transform_sec_id()
		#$d_ref->{$oname} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};  ##commented during build 1 fix. changed to next line.
		$d_ref->{$oname} = $d_ref->{$oname};
	},
	'B82833961' => sub {                                                #v900r011
		my ( $d_ref, $blockname, $oname ) = @_;
		my ( $f1, @rest ) = split( '/', $d_ref->{$oname}, 3 );
		$d_ref->{Processor_Type} = $d_ref->{RNC_ID} . '/' . $f1;        #should be in transform_sec_id()
		#$d_ref->{$oname} = $d_ref->{RNC_ID} . "/" . $d_ref->{$oname};  ## commented during build 1 fix
		$d_ref->{$oname} = $d_ref->{$oname};
	},
  }

  ;

sub proc_id {
	my ( $d_ref, $blockname, $oname ) = @_;

	my $id_counter = 1;

	$d_ref->{PROC_ID} = $d_ref->{$oname};

	foreach my $subproc ( split /\//, $d_ref->{PROC_ID} ) {
		$d_ref->{ "PROC" . $id_counter . "_ID" } = $subproc;
		++$id_counter;
	}

	#delete $d_ref->{$oname};
	return 0;
}

sub process_object_name {
	my ( $d_ref, $blockname, $oname ) = @_;

	#simple split not enuff for initial split
	my @object_name;
	$d_ref->{$oname} =~ s/([^\w])_(\w+)/\1\2/g;    #this is to get rid of uglies like ',_INDEX_11' to get ' ',INDEX_11'
	my @arr = split /\//, $d_ref->{$oname};
	my $tmp = shift @arr;
	while (@arr) {
		my $t2 = shift @arr;
		if ( $t2 =~ /:/ ) {
			push( @object_name, $tmp );
			$tmp = $t2;
		}
		else {
			$tmp .= "/$t2";
		}
	}
	push @object_name, $tmp if length($tmp) > 0;    #dun forget last one

	my $counter = 0;
	my $placeholder;
	foreach my $oname_ori (@object_name) {
		if ( $counter > 0 && $oname_ori =~ /\:/ ) {    # not first counter and has ":" in it
			$d_ref->{ "Object_Name_" . $counter } = $oname_ori;
			$d_ref->{ "Object_Name_" . $counter } =~ tr/\.\-\ \=/____/s;
			$placeholder = "Object_Name_" . $counter;
			$counter++;
		}
		elsif ( $counter > 0 ) {                       # not first counter and has no ":" in it append to the previous one
			$d_ref->{$placeholder} .= "/" . $oname_ori;
		}
		else {                                         # set the first one as its always assumed to be RNC_ID
			$d_ref->{ "Object_Name_" . $counter } = $oname_ori;
			$d_ref->{ "Object_Name_" . $counter } =~ tr/\.\-\ \=/____/s;
			$counter++;
		}
	}

	# First one assumed to be RNC, set the rest to generic OBJECT_ID

	if ( exists( $d_ref->{Object_Name_0} ) ) {
		$d_ref->{RNC_ID} = $d_ref->{Object_Name_0};
		$d_ref->{Object_Name} =~ /^$d_ref->{RNC_ID}\/(.*)/;
		$d_ref->{OBJECT_ID} = $1;
		$d_ref->{OBJECT_ID} =~ tr/\:\,\=/\/\/_/;

		#$d_ref->{OBJECT_ID} =~ s/_*\/_*/\//g;

		delete $d_ref->{Object_Name_0};
		delete $d_ref->{Object_Name};

		#do primary OBJECT_ID processing here
		transform_pri_id( $d_ref, $blockname, 'OBJECT_ID' );

	}

	# Rename all other split object names
	foreach my $oname_new ( grep { /Object_Name_/ } keys %{$d_ref} ) {
		transform_sec_id( $d_ref, $blockname, $oname_new );
	}
}

sub transform_pri_id {
	my ( $d_ref, $blockname, $oname ) = @_;
	my $op = $obj_id_xform->{$blockname};
	if ( $op && ref( \$op ) eq 'SCALAR' ) {
		$d_ref->{$op} = $d_ref->{$oname};
		delete $d_ref->{$oname};
	}
	elsif ( ref($op) eq 'CODE' ) {
		$op->( $d_ref, $blockname, $oname );
	}

	#no change
}

sub transform_sec_id {

	my ( $d_ref, $blockname, $oname ) = @_;

	for ( $d_ref->{$oname} ) {
		/^Cell\:(.*)/ && do {
			$d_ref->{CELL_ID} = $1;
			if ( $d_ref->{CELL_ID} =~ /(Label.*),/ ) {
				$d_ref->{Cell_Label} = $1;
			}
			else {
				$d_ref->{Cell_Label} = $d_ref->{CELL_ID};
			}
			$d_ref->{CELL_ID} =~ s/Label(\w+)[,\/]//g;    #remove the optional label
			delete $d_ref->{$oname};
			last;
		};
		/^SAALLink\:(.*)/ && do {
			$d_ref->{SAALLINK_ID} = $1;
			foreach my $sub_oname ( split /\,/, $d_ref->{SAALLINK_ID} ) {
				$sub_oname =~ /([a-zA-Z0-9]+)_(.+)/;
				$d_ref->{$1} = $2;
			}
			$d_ref->{SAALLINK_ID} =~ tr/\,/\//;

			( $d_ref->{SS7_POINT_ID} ) = split /,/, $d_ref->{$oname};
			$d_ref->{SS7_POINT_ID} =~ s/\:/\//g;
			$d_ref->{SS7_POINT_ID} = $d_ref->{RNC_ID} . "/" . $d_ref->{SS7_POINT_ID};

			( $d_ref->{SS7_LINKSET_ID} ) = $d_ref->{$oname};
			$d_ref->{SS7_LINKSET_ID} =~ s/\:/\//g;
			$d_ref->{SS7_LINKSET_ID} =~ /(SRN_\w+).+(SSN_\w+)/;
			$d_ref->{SS7_LINKSET_ID} = $d_ref->{RNC_ID} . "/SAALLINK/" . $1 . "/" . $2;

			delete $d_ref->{$oname};
			last;
		};
		/^SAALLNK\:(.*)/ && do {    #v900r011, is better to be put in transform_pri_id
			my $afterSAALLNK = $1;

			#only take the first list item, e.g. SAALLNK:SRN_0 from SAALLNK:SRN_0,SN_0,LNKN_102
			( $d_ref->{SS7_POINT_ID} ) = split /,/, $d_ref->{$oname};
			$d_ref->{SS7_POINT_ID} =~ s/SAALLNK\://;
			$d_ref->{SS7_POINT_ID} = $d_ref->{RNC_ID} . "/SAALLink/" . $d_ref->{SS7_POINT_ID};

			$afterSAALLNK = /(SRN_\w+).+(SN_\w+)/;
			$d_ref->{SS7_LINKSET_ID} = $d_ref->{RNC_ID} . "/SAALLINK/" . $1 . '/' . $2;

			delete $d_ref->{$oname};
			last;
		};
		/^Frame\:(.*)/ && do {
			$d_ref->{FRAME_ID} = $1;
			delete $d_ref->{$oname};
			last;
		};
		/^CPU\:(.*)/ && do {
			$d_ref->{CPU_ID} = $1;
			$d_ref->{Processor_Type} = 'CPU' if ( not exists $d_ref->{Processor_Type} );
			delete $d_ref->{$oname};
			last;
		};
		/^Sub_System\:(.*)/ && do {
			$d_ref->{SUBSYSTEM_ID} = $1;
			delete $d_ref->{$oname};
			last;
		};
		/^SCCP_Type\:(.*)/ && do {
			$d_ref->{SCCP_ID} = $1;
			delete $d_ref->{$oname};
			last;
		};
		/^QAAL2\:(.*)/ && do {
			$d_ref->{ATM_NODE_ID} = $1;
			delete $d_ref->{$oname};
			last;
		};
		/^MTP3BLink\:(.*)/ && do {
			$d_ref->{SS7_LINK_ID}    = $1;
			$d_ref->{SS7_POINT_ID}   = $d_ref->{RNC_ID};
			$d_ref->{SS7_LINKSET_ID} = $d_ref->{RNC_ID} . "/" . $d_ref->{OBJECT_ID};
			$d_ref->{SS7_LINKSET_ID} =~ tr/\,\:/\/\//;
			$d_ref->{SS7_LINKSET_ID} =~ s/\/SLC.*$//g;

			$d_ref->{SS7_LINK_ID} =~ tr/\,/\//;
			foreach my $sub_oname ( split /\//, $d_ref->{SS7_LINK_ID} ) {
				$sub_oname =~ /([a-zA-Z0-9]+)_(\w+)/;
				$d_ref->{$1} = $2;
			}
			$d_ref->{SS7_LINK_ID} =~ s/RNC_/manipRNC/g;
			$d_ref->{SS7_LINK_ID} = $d_ref->{OBJECT_ID};
			$d_ref->{SS7_LINK_ID} =~ s/\w+_(\w+)/\1/g;
			$d_ref->{SS7_LINK_ID} =~ s/manipRNC/RNC_/g;
			delete $d_ref->{$oname};
			last;
		};

		# becareful that in R10 when MTP3BLink and MTP3BLinkSet come together,
		# PIF handler not able to handle them, therefore if MTP3BLink come first,
		# the SS7_LINKSET_ID and SS7_POINT_ID is required to be proceesed in EngineConfig.pm
		/^MTP3BLinkSet\:(.*)/ && do {

			$d_ref->{SS7_LINKSET_ID} = $d_ref->{RNC_ID} . "/" . $d_ref->{OBJECT_ID};
			$d_ref->{SS7_LINKSET_ID} =~ tr/\,\:/\/\//;
			$d_ref->{SS7_POINT_ID} = $d_ref->{RNC_ID};

			foreach my $sub_oname ( split /\//, $d_ref->{SS7_LINKSET_ID} ) {
				$sub_oname =~ /([a-zA-Z0-9]+)_(\w+)/;
				$d_ref->{$1} = $2;
			}

			delete $d_ref->{$oname};
			last;
		};
		/^MTP3BDsp\:(.*)/ && do {
			$d_ref->{SS7_POINT_ID} = $1;
			$d_ref->{SS7_POINT_ID} =~ tr/\=/_/;
			delete $d_ref->{$oname};
			last;
		};
		/^IUR\:(.*)/ && do {
			$d_ref->{IUR_INTERFACE_ID} = $1;
			delete $d_ref->{$oname};
			last;
		};
		/^IU\:(.*)/ && do {
			$d_ref->{IU_INTERFACE_ID} = $1;
			$d_ref->{IU_INTERFACE_ID} =~ tr/\,/\//;
			delete $d_ref->{$oname};
			last;
		};
		/^Board\:(.*)/ && do {
			$d_ref->{BOARD_ID} = $1;
			my @board_arr = split /\,/, $d_ref->{BOARD_ID};
			foreach my $sub_oname (@board_arr) {
				$sub_oname =~ /([a-zA-Z0-9]+)_(\w+)/;
				$d_ref->{$1} = $2;
			}
			if ( exists $d_ref{BT} ) {
				( $d_ref->{Processor_Type} ) = split /\//, $d_ref{BT};
			}
			else {
				$d_ref->{Processor_Type} = $1 if $d_ref->{BOARD_ID} =~ /BT_(\w+)[,]*/;
			}
			$d_ref->{BOARD_ID} =~ tr/\,/\//;
			delete $d_ref->{$oname};
			last;
		};
		/^MNC\:(.*)/ && do {
			$d_ref->{MNC_ID} = $1;
			$d_ref->{MNC_ID} =~ tr/\:/\//;
			( $d_ref->{MNC1_ID}, $d_ref->{MNC2_ID}, $d_ref->{MNC3_ID} ) = split /\//, $d_ref->{MNC_ID};
			delete $d_ref->{$oname};
			last;
		};
		/^MCC\:(.*)/ && do {
			$d_ref->{MCC_ID} = $1;
			delete $d_ref->{$oname};
			last;
		};
		/^RNC\:(.*)/ && do {
			$d_ref->{DEST_RNC_ID} = $1;
			delete $d_ref->{$oname};
			last;
		};
		/^DEST_Cell_ID\:(.*)/ && do {
			$d_ref->{DEST_CELL_ID} = "CellID_" . $1;
			delete $d_ref->{$oname};
			last;
		};
		/^GTPU\:(.*)/ && do {
			$d_ref->{GPRS_TUNNEL_ID} = $1;
			delete $d_ref->{$oname};
			last;
		};
		/^WHPU\:(.*)/ && do {
			$d_ref->{WHPU_ID} = $1;
			$d_ref->{WHPU_ID} =~ tr/\,\=/\/_/;
			$d_ref->{Processor_Type} = $d_ref->{PROC1_ID};
			delete $d_ref->{$oname};
			last;
		};
		/^IMAGRP\:(.*)/ && do {
			my $ima_group_id = $1;
			$ima_group_id =~ tr/\,\=/\/_/;

			$d_ref->{SS7_POINT_ID} = $d_ref->{RNC_ID} . '/' . $ima_group_id;
			$d_ref->{SS7_POINT_ID} =~ s/\/IMAGRPN.*//g;

			foreach my $sub_oname ( split /\//, $d_ref->{SS7_LINKSET_ID} ) {
				$sub_oname =~ /([a-zA-Z0-9]+)_(\w+)/;
				$d_ref->{$1} = $2;
			}

			$d_ref->{SS7_LINKSET_ID} = $d_ref->{OBJECT_ID};
			delete $d_ref->{$oname};
			last;
		};
		/^IMAGROUP\:(.*)/ && do {
			my $ima_group_id = $1;
			$ima_group_id =~ tr/\,\=/\/_/;

			$d_ref->{SS7_POINT_ID} = $d_ref->{RNC_ID} . '/' . $ima_group_id;
			$d_ref->{SS7_POINT_ID} =~ s/\/IMAGRPN.*//g;

			foreach my $sub_oname ( split /\//, $d_ref->{SS7_LINKSET_ID} ) {
				$sub_oname =~ /([a-zA-Z0-9]+)_(\w+)/;
				$d_ref->{$1} = $2;
			}

			$d_ref->{SS7_LINKSET_ID} = $d_ref->{OBJECT_ID};
			delete $d_ref->{$oname};
			last;
		};
		/^IMALNK\:(.*)/ && do {
			my $data = $1;
			$data =~ tr/\,\=/\/_/;

			( $d_ref->{SS7_POINT_ID}, $d_ref->{SS7_LINKSET_ID}, $d_ref->{SS7_LINK_ID} ) = split( /\//, $data );
			$d_ref->{SS7_POINT_ID} = $d_ref->{RNC_ID} . "/" . $d_ref->{SS7_POINT_ID} . "/" . $d_ref->{SS7_LINKSET_ID};

			foreach my $sub_oname ( split /\//, $data ) {
				$sub_oname =~ /([a-zA-Z0-9]+)_(\w+)/;
				$d_ref->{$1} = $2;
			}

			$d_ref->{SS7_LINKSET_ID} = $d_ref->{OBJECT_ID};

			delete $d_ref->{$oname};
			last;
		};
		/^RncFunction\:(.*)/ && do {
			$d_ref->{RNC_ID} = $1;
			delete $d_ref->{$oname};
			last;
		};
		/^LocalCell\:(.*)/ && do {
			$d_ref->{Local_Cell_Id} = $1;
			$d_ref->{NodeB_Id}      = $d_ref->{RNC_ID};
			delete $d_ref->{$oname};
			delete $d_ref->{RNC_ID};
			last;
		};
		/^NodeB\:(.*)/ && do {
			$d_ref->{NodeB_Id} = $1;
			delete $d_ref->{$oname};
			last;
		};
		/^NODEB\:(.*)/ && do {
			$d_ref->{NodeB_Id}         = $1;
			$d_ref->{NodeB_Map_RNC_Id} = $d_ref->{NodeB_Id};
			$d_ref->{NodeB_Map_RNC_Id} =~ s/NodeB_Name_//g;
			delete $d_ref->{$oname};
			last;
		};
		/^MocID\:(.*)/ && do {
			$d_ref->{Moc_Id} = $1;
			delete $d_ref->{$oname};
			last;
		};
		/^Operator\:(.*)/ && do {
			$d_ref->{Operator_Id} = $1;
			$d_ref->{Operator_Id} =~ s/^\_(.*)/-\1/g;
			delete $d_ref->{$oname};
			last;
		};
		/^SPU\:(.*)/ && do {
			$d_ref->{SPU_ID} = $1;
			delete $d_ref->{$oname};
			last;
		};
		/^CSU\:(.*)/ && do {
			$d_ref->{Processor_Type} = $d_ref->{RNC_ID} . "/" . $d_ref->{PROC1_ID};
			$d_ref->{OBJECT_ID}      = "$d_ref->{RNC_ID}/$d_ref->{OBJECT_ID}";
			delete $d_ref->{$oname};
			last;
		};
		/^GCU\:(.*)/ && do {
			$d_ref->{Processor_Type} = $d_ref->{RNC_ID} . "/" . $d_ref->{PROC1_ID};
			$d_ref->{OBJECT_ID}      = "$d_ref->{RNC_ID}/$d_ref->{OBJECT_ID}";
			delete $d_ref->{$oname};
			last;
		};
		/^PIU\:(.*)/ && do {
			$d_ref->{Processor_Type} = $d_ref->{RNC_ID} . "/" . $d_ref->{PROC1_ID};
			$d_ref->{OBJECT_ID}      = "$d_ref->{RNC_ID}/$d_ref->{OBJECT_ID}";
			delete $d_ref->{$oname};
			last;
		};
		/^INTERWORKING\:(.*)/ && do {
			$d_ref->{Processor_Type} = $d_ref->{RNC_ID} . "/" . $d_ref->{PROC1_ID};
			$d_ref->{OBJECT_ID}      = "$d_ref->{RNC_ID}/$d_ref->{OBJECT_ID}";
			delete $d_ref->{$oname};
			last;
		};
		/^SCU\:(.*)/ && do {
			$d_ref->{Processor_Type} = $d_ref->{RNC_ID} . "/" . $d_ref->{PROC1_ID};
			$d_ref->{OBJECT_ID}      = "$d_ref->{RNC_ID}/$d_ref->{OBJECT_ID}";
			delete $d_ref->{$oname};
			last;
		};
		/^DPU\:(.*)/ && do {
			$d_ref->{Processor_Type} = $d_ref->{RNC_ID} . "/" . $d_ref->{PROC1_ID};
			$d_ref->{OBJECT_ID}      = "$d_ref->{RNC_ID}/$d_ref->{OBJECT_ID}";
			delete $d_ref->{$oname};
			last;
		};
		/^MPU\:(.*)/ && do {
			$d_ref->{Processor_Type} = $d_ref->{RNC_ID} . "/" . $d_ref->{PROC1_ID};
			$d_ref->{OBJECT_ID}      = "$d_ref->{RNC_ID}/$d_ref->{OBJECT_ID}";
			delete $d_ref->{$oname};
			last;
		};
		/^CNOPERATOR\:(.*)/ && do {
			my $data = $1;
			my @arr = split /\,/, $data;
			foreach my $sub_oname (@arr) {
				$sub_oname =~ /(\w+)_(.+)/;
				$d_ref->{$1} = $2;
			}
			$d_ref->{CNNAME} = $d_ref->{RNC_ID} if ( !exists $d_ref->{CNNAME} );
			$d_ref->{CNINDEX} = '0' if ( !exists $d_ref->{CNINDEX} );
			delete $d_ref->{$oname};
			last;
		  },

		  # We don't know what it is. Use primary id
		  delete $d_ref->{$oname};
	}
}

1;


